﻿Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Me.Label3.Text = "ソースファイルをチェックアウトしています"
        Me.Label3.Refresh()
        System.Threading.Thread.Sleep(1000)

        fncGetsrc("")
        Me.Label3.Text = "ソースファイルをチェックアウトしています2"
        Me.Label3.Refresh()
        fncGetsrc("")

        Me.Label3.Text = "設定ファイルを更新しています"
        ''My.Computer.FileSystem.CopyDirectory("D:\test", "E:\test", FileIO.UIOption.AllDialogs, FileIO.UICancelOption.DoNothing)
        ''My.Computer.FileSystem.CopyDirectory("D:\test", "E:\tesB", FileIO.UIOption.AllDialogs, FileIO.UICancelOption.DoNothing)
        ''My.Computer.FileSystem.CopyDirectory("D:\test", "E:\tesB", True, FileIO.UICancelOption.DoNothing)
        CopyDirectory("D:\test\", "E:\tert\", True)

        Me.Label3.Text = "終了しました"
    End Sub


    Private Sub fncGetsrc(ByVal Path)
        'Processオブジェクトを作成
        Dim p As New System.Diagnostics.Process()

        'ComSpec(cmd.exe)のパスを取得して、FileNameプロパティに指定
        p.StartInfo.FileName = System.Environment.GetEnvironmentVariable("ComSpec")
        '出力を読み取れるようにする
        p.StartInfo.UseShellExecute = False
        p.StartInfo.RedirectStandardOutput = True
        p.StartInfo.RedirectStandardInput = False
        'ウィンドウを表示しないようにする
        p.StartInfo.CreateNoWindow = False
        'コマンドラインを指定（"/c"は実行後閉じるために必要）
        p.StartInfo.Arguments = "/c " + "ping -n 10 localhost"

        '起動
        p.Start()

        '出力を読み取る
        Dim results As String = p.StandardOutput.ReadToEnd()

        'プロセス終了まで待機する
        'WaitForExitはReadToEndの後である必要がある
        '(親プロセス、子プロセスでブロック防止のため)
        p.WaitForExit()
        p.Close()

        '出力された結果を表示
        Console.WriteLine(results)

    End Sub


    ''' ------------------------------------------------------------------------------------
    Public Overloads Shared Sub CopyDirectory(ByVal stSourcePath As String, ByVal stDestPath As String)
        CopyDirectory(stSourcePath, stDestPath, False)
    End Sub

    ''' ------------------------------------------------------------------------------------
    ''' <summary>
    '''     ファイルまたはディレクトリ、およびその内容を新しい場所にコピーします。<summary>
    ''' <param name="stSourcePath">
    '''     コピー元のディレクトリのパス。</param>
    ''' <param name="stDestPath">
    '''     コピー先のディレクトリのパス。</param>
    ''' <param name="bOverwrite">
    '''     コピー先が上書きできる場合は True。それ以外の場合は False。</param>
    ''' ------------------------------------------------------------------------------------
    Public Overloads Shared Sub CopyDirectory(ByVal stSourcePath As String, ByVal stDestPath As String, ByVal bOverwrite As Boolean)
        ' コピー先のディレクトリがなければ作成する
        If System.IO.Directory.Exists(stDestPath) = False Then
            System.IO.Directory.CreateDirectory(stDestPath)
            System.IO.File.SetAttributes(stDestPath, System.IO.File.GetAttributes(stSourcePath))
            bOverwrite = True
        End If

        ' コピー元のディレクトリにあるすべてのファイルをコピーする
        If bOverwrite Then
            For Each stCopyFrom As String In System.IO.Directory.GetFiles(stSourcePath)
                Dim stCopyTo As String = System.IO.Path.Combine(stDestPath, System.IO.Path.GetFileName(stCopyFrom))
                System.IO.File.Copy(stCopyFrom, stCopyTo, True)
            Next stCopyFrom

            ' 上書き不可能な場合は存在しない時のみコピーする
        Else
            For Each stCopyFrom As String In System.IO.Directory.GetFiles(stSourcePath)
                Dim stCopyTo As String = System.IO.Path.Combine(stDestPath, System.IO.Path.GetFileName(stCopyFrom))

                If System.IO.File.Exists(stCopyTo) = False Then
                    System.IO.File.Copy(stCopyFrom, stCopyTo, False)
                End If
            Next stCopyFrom
        End If

        ' コピー元のディレクトリをすべてコピーする (再帰)
        For Each stCopyFrom As String In System.IO.Directory.GetDirectories(stSourcePath)
            Dim stCopyTo As String = System.IO.Path.Combine(stDestPath, System.IO.Path.GetFileName(stCopyFrom))
            CopyDirectory(stCopyFrom, stCopyTo, bOverwrite)
        Next stCopyFrom
    End Sub
End Class
